@echo off

rem #  ------------------------------------------------------------
rem #  Company: Software- und Organisations-Service GmbH
rem #  Purpose: Watchdog script for JobScheduler Agent
rem #  ------------------------------------------------------------

start "JobSchedulerAgent" /D "%SCHEDULER_WORK_DIR%" /B /WAIT "%JAVAWBIN%" -DLOGFILE="%SCHEDULER_LOGFILE%" %JAVA_OPTIONS% -classpath "%SCHEDULER_CLASSPATH%" com.sos.scheduler.engine.agent.main.AgentMain -http-port=%SCHEDULER_HTTP_PORT% %HTTPS_PORT_OPTION% -data-directory="%SCHEDULER_DATA%" -log-directory="%SCHEDULER_LOG_DIR%" %KILL_SCRIPT_OPTION% -job-java-options="-DLOGFILE=%SCHEDULER_LOGFILE%"
if not ERRORLEVEL 1 goto finally

echo %DATE% %TIME% [info]  JobScheduler Agent terminated abnormal >> "%SCHEDULER_LOGFILE%.log"
echo %DATE% %TIME% [info]  Watchdog calls "%SCHEDULER_CRASH_FILE%" >> "%SCHEDULER_LOGFILE%.log"
if not exist "%SCHEDULER_CRASH_FILE%" (
  echo %DATE% %TIME% [info]  "%SCHEDULER_CRASH_FILE%" doesn't exist >> "%SCHEDULER_LOGFILE%.log"
  goto finally
)
call :crash_file_when_not_empty "%SCHEDULER_CRASH_FILE%"
goto finally

:crash_file_when_not_empty
set /a SCHEDULER_CRASH_FILE_SIZE=%~z1
if %SCHEDULER_CRASH_FILE_SIZE% equ 0 (
  echo %DATE% %TIME% [info]  "%SCHEDULER_CRASH_FILE%" is empty. Nothing to do. >> "%SCHEDULER_LOGFILE%.log"
  goto finally
)
call "%SCHEDULER_CRASH_FILE%" > "%KILL_TASK_LOG_FILE%" 2>&1

:finally
exit %ERRORLEVEL%